/**********************************************************************
SQL Server Internals from the Practical Angle

Dmitri Korotkevitch
http://aboutsqlserver.com
dmitri@aboutsqlserver.com

Locking and Blocking: Deadlocks (Session 2)
**********************************************************************/

use TroubleshootingDb
go

set nocount on
go

if exists
(
	select *
	from sys.procedures p join sys.schemas s on 
		p.schema_id = s.schema_id
	where
		s.name = 'dbo' and p.name = 'DoDeadlock'
)
	drop proc dbo.DoDeadlock
go

create proc dbo.DoDeadlock
as
begin
	set transaction isolation level read uncommitted
	begin tran
		update dbo.SmallRow set CharField = 'b' where ID = 1000
		raiserror('First update is done',0,1) with nowait
		update dbo.SmallRow set CharField = 'b' where IntField = 1001
	commit
end
go

exec dbo.DoDeadlock